# -*- coding: utf-8 -*-
"""
Created on Mon Jan 7 20:57:56 2017

@author: jean-michelferrard
"""
from tkinter import *
from turtle import * # importe le package turtle
import turtle

import sys

compteur = 0 # pour numéroter les images

from time import sleep

import numpy as np
from PIL import Image
import io    

### Un objet écran
EC = Screen()
EC.clear()

### Un objet Turtle
CA = Turtle()

##############
### Choisir ici le nom du gif
### représentant une reine
### Il doit être dans le répertoire
### de travail
nomgif="queen.gif"
##############

def case(x, y, long, coul):
    '''dessin d'une case'''
    '''Remplit un carré d'arête longueur, à partir du sommet (x, y).
    Le premier coté est tracé dans la direction initiale de la tortue.
    Le contour du carré est dessiné dans le sens horaire.
    À la sortie, la tortue est en (x,y), dans la direction initiale'''
    CA.up();                # lève le crayon
    CA.goto(x, y);          # se déplace au point (x,y)
    CA.down()               # baisse le crayon
    CA.color(coul)          # règle couleur de remplissage
    CA.begin_fill()         # on va remplir le carré
    for k in range(4):   # quatre fois de suite
       CA.forward(long)     #   trace un coté
       CA.left(90)          #   tourne de 90° vers la gauche
    CA.end_fill()           # retour au départ et remplit
    
def savefig():
    '''sauvegarde l'image de l'échiquier'''
    global compteur
    compteur +=1
    if compteur > 1000:
        sys.exit("Trop d'étapes!")
    nom = "reines"+str(1000+compteur)[1:]
    screen = turtle.getscreen()
    canvas = screen.getcanvas()
    postscript = canvas.postscript(file=nom+'.eps')
    

def ok(j):
    '''renvoie True si la reine j,
    actuellement placée dans la ligne Q[j]
    n'est en prise avec aucune des reines
    d'indice < j, et False sinon'''
    for i in range(j):
        if (Q[i] == Q[j]) or (abs(Q[j]-Q[i]) == abs(j-i)):
            return False
    return True

def plotsol(Q):
    vitesse=0
    print(Q)
    n = len(Q)
    InitEchiq(n)
    TQ=[]
    for j in range(n):
        q = turtle.Turtle()
        #q.hideturtle()
        q.up()
        q.shape(nomgif)
        q.resizemode("user")
        q.shapesize(1.5, 1.5)
        q.speed(vitesse)
        q.pensize(0)
        q.goto(j*AR+AR/2, Q[j]*AR+AR/2 )
        TQ.append(q)
    savefig()
    
def place(j,taille):
    '''place récursivement la reine de la colonne j'''
    global sols, TQ, AR
    if j==taille:
        sols.append(Q[:])
        #plotsol(Q)
        savefig()
        #sys.exit()
    else:
        for i in range(taille):
            Q[j] = i;
            if ok(j):
                TQ[j].goto(j*AR+AR/2, i*AR+AR/2 )
                TQ[j].showturtle()
                place(j+1,taille)
        TQ[j].hideturtle()

def affsol(s):
    '''affichage d'une solution en mode texte'''
    n = len(s)
    print('-'*(2*n+3))
    for i in range(n):
        st = '|'
        for j in range(n):
          st = st + (' Q' if s[j]==i else ' *')
        print(st + ' |')
    print('-'*(2*n+3)+'\n')

def InitEchiq(N):
    '''Initialise les objets échiquier et cavalier'''
    global AR, EC
    size = 600                  # taille fenêtre carrée, en pixels
    AR = size//N                # taille arête d'une case
    # initialisation de l'objet échiquier
    EC = turtle.Screen()
    EC.clear()
    EC.register_shape(nomgif)
    EC.setworldcoordinates(0,size,size,0)   # fenêtre 600*600
    EC.tracer(0)
    for i in range(N):
        for j in range(N):
            color = ["brown","yellow"][(i+j)%2]
            case(i*AR, j*AR, AR,color)
    EC.tracer(1)
    
def InitTurtles(n,vitesse):
    global TQ
    TQ=[]
    for j in range(n):
        q = turtle.Turtle()
        q.up()
        q.shape(nomgif)
        q.resizemode("user")
        q.shapesize(1, 1)
        q.speed(vitesse)
        q.pensize(0)
        TQ.append(q)

   
def nreines(n=8, vitesse=0):
    global sols, Q, tq, EC
    Q = [-1]*n
    sols = []
    InitEchiq(n)
    InitTurtles(n,vitesse)
    place(0,n)
    print('Il y a eu {} solutions\\n'.format(len(sols)))
    for k in range(len(sols)):
        print('solution n°{}'.format(k+1))
        affsol(sols[k])      
        
        